#ifndef __RT_TIME_H__
#define __RT_TIME_H__

#include <asm/arithm.h>

#ifdef __KERNEL__
#include <linux/time.h>
extern int rt_latch2;
#endif

#define RT_TICKS_PER_SEC 1193180LL

typedef long long RTIME;

extern RTIME rt_linux_clock;

extern RTIME rt_base_time;

extern RTIME rt_get_time(void);

extern int rt_request_timer(void (*rt_timer_handler)(void), int rt_tick_period);

extern void rt_free_timer(void);

static inline RTIME rt_ts_to_rtime(struct timespec *res)
{
	return res->tv_sec * RT_TICKS_PER_SEC + imuldiv(res->tv_nsec, RT_TICKS_PER_SEC, 1000000000);
}

extern RTIME rt_get_prof_time(void);

#endif
